%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global with_doc 0
%global service cinder

%global common_desc \
OpenStack Volume (codename Cinder) provides services to manage and \
access block storage volumes for use by Virtual Machine instances.

Name:             openstack-%{service}
# Liberty semver reset
# https://review.openstack.org/#/q/I6a35fa0dda798fad93b804d00a46af80f08d475c,n,z
Epoch:            1
Version:          12.0.4
Release:          8%{?dist}
Summary:          OpenStack Volume service

License:          ASL 2.0
URL:              http://www.openstack.org/software/openstack-storage/
Source0:          https://tarballs.openstack.org/%{service}/%{service}-%{upstream_version}.tar.gz

# patches_ignore=DROP-IN-RPM
# patches_base=12.0.4
Patch0001: 0001-RBD-Enable-cinder-exclusive-pool-by-default.patch
Patch0002: 0002-NetApp-SolidFire-Fix-force_detach.patch
Patch0003: 0003-NetApp-SolidFire-Fix-CG-snapshot-deletion.patch
Patch0004: 0004-nimble-storage-support-for-force-detach.patch
Patch0005: 0005-Handling-type-s-multiattach-extra-specs-in-API-task-.patch
Patch0006: 0006-VMAX-Queens-90-endpoint-not-compatible-with-unispher.patch
Patch0007: 0007-Fix-backup-restore-error-for-ceph-rbd-backend.patch
Patch0008: 0008-Storwize-modify-hyperswap-host_site-configuration.patch
Patch0009: 0009-Ensure-image-utils-don-t-block-greenthreads.patch
Patch0010: 0010-lvm-Avoid-premature-calls-to-terminate_connection-fo.patch
Patch0011: 0011-VMAX-Driver-VMAX-OS-Upgrade-Bug.patch
Patch0012: 0012-cinder-volume-Stop-masking-IOError-different-than-EN.patch
Patch0013: 0013-SF-ensure-the-correct-volume-is-deleted.patch
Patch0014: 0014-Fix-non-iSCSI-attach-serialization.patch
Patch0015: 0015-LVM-Disable-multiattach-for-LIO-iSCSI-target.patch
Patch0016: 0016-lvm-Avoid-premature-calls-to-terminate_connection-fo.patch
Patch0017: 0017-Remove-cinder-tox-compliance-job.patch
Patch0018: 0018-Correct-default-policy-file.patch
Patch0019: 0019-Stop-cleaning-images-to-be-deleted-in-remotefs-drive.patch
Patch0020: 0020-Handle-rbd.OSError-on-broken-RBD-image.patch
Patch0021: 0021-Consume-quota-when-importing-backup-resource.patch
Patch0022: 0022-Retry-on-DBDeadLock-affecting-worker-updates.patch
Patch0023: 0023-Add-secret-true-to-fixed_key-configuration-parameter.patch

Source1:          %{service}-dist.conf
Source2:          %{service}.logrotate

Source10:         openstack-%{service}-api.service
Source11:         openstack-%{service}-scheduler.service
Source12:         openstack-%{service}-volume.service
Source13:         openstack-%{service}-backup.service
Source20:         %{service}-sudoers


BuildArch:        noarch
BuildRequires:    intltool
BuildRequires:    python2-openstackdocstheme
BuildRequires:    python2-pbr
BuildRequires:    python2-reno
BuildRequires:    python2-sphinx
BuildRequires:    python2-devel
BuildRequires:    python2-setuptools
BuildRequires:    python2-netaddr
BuildRequires:    systemd
BuildRequires:    git
BuildRequires:    openstack-macros
BuildRequires:    os-brick
BuildRequires:    python2-pyparsing
BuildRequires:    python2-pytz
BuildRequires:    python-decorator
BuildRequires:    openstack-macros
# Required to build cinder.conf
BuildRequires:    python-google-api-client >= 1.4.2
BuildRequires:    python2-keystonemiddleware
BuildRequires:    python2-glanceclient >= 2.8.0
BuildRequires:    python2-novaclient >= 9.1.0
BuildRequires:    python2-swiftclient >= 3.2.0
BuildRequires:    python2-oslo-db
BuildRequires:    python2-oslo-config >= 2:5.1.0
BuildRequires:    python2-oslo-policy
BuildRequires:    python2-oslo-reports
BuildRequires:    python2-oslotest
BuildRequires:    python2-oslo-utils
BuildRequires:    python2-oslo-versionedobjects
BuildRequires:    python2-oslo-vmware
BuildRequires:    python2-os-win
BuildRequires:    python2-castellan
BuildRequires:    python2-cryptography
BuildRequires:    python-lxml
BuildRequires:    python2-osprofiler
BuildRequires:    python2-paramiko
BuildRequires:    python2-suds
BuildRequires:    python2-taskflow
BuildRequires:    python2-tooz
BuildRequires:    python2-oslo-log
BuildRequires:    python2-oslo-i18n
BuildRequires:    python2-barbicanclient
BuildRequires:    python2-requests
BuildRequires:    python-retrying
BuildRequires:    python2-defusedxml

# Required to compile translation files
BuildRequires:    python2-babel

# Needed for unit tests
BuildRequires:    python2-ddt
BuildRequires:    python2-fixtures
BuildRequires:    python2-mock
BuildRequires:    python2-oslotest
BuildRequires:    python2-subunit
BuildRequires:    python2-testtools
BuildRequires:    python2-testrepository
BuildRequires:    python2-testresources
BuildRequires:    python2-testscenarios
BuildRequires:    python2-os-testr
BuildRequires:    python-rtslib

Requires:         python-%{service} = %{epoch}:%{version}-%{release}

# we dropped the patch to remove PBR for Delorean
Requires:         python2-pbr

# as convenience
Requires:         python2-cinderclient

%{?systemd_requires}
Requires(pre):    shadow-utils

Requires:         lvm2
Requires:         python2-osprofiler
Requires:         python-rtslib
Requires:         python-pyudev

# required for cinder-manage
Requires:         python-prettytable >= 0.7.1

%description
%{common_desc}


%package -n       python-%{service}
Summary:          OpenStack Volume Python libraries
Group:            Applications/System

Requires:         sudo

Requires:         qemu-img
Requires:         sysfsutils
Requires:         os-brick >= 2.1.1
Requires:         python2-paramiko >= 2.0
Requires:         python-simplejson >= 3.5.1
Requires:         python2-jsonschema >= 2.6.0
Requires:         python2-os-win >= 3.0.0
Requires:         python2-oslo-vmware >= 2.17.0

Requires:         python2-castellan >= 0.16.0
Requires:         python2-eventlet >= 0.18.2
Requires:         python2-greenlet >= 0.4.10
Requires:         python2-iso8601 >= 0.1.11
Requires:         python-lxml >= 3.2.1
Requires:         python2-stevedore >= 1.20.0
Requires:         python2-suds
Requires:         python2-tooz >= 1.58.0

Requires:         python2-sqlalchemy >= 1.0.10
Requires:         python-migrate >= 0.11.0

Requires:         python-paste
Requires:         python-paste-deploy
Requires:         python2-routes >= 2.3.1
Requires:         python-webob >= 1.7.1

Requires:         python2-glanceclient >= 1:2.8.0
Requires:         python2-swiftclient >= 3.2.0
Requires:         python2-keystoneclient >= 1:3.8.0
Requires:         python2-novaclient >= 9.1.0

Requires:         python2-oslo-config >= 2:5.1.0
Requires:         python2-six >= 1.10.0
Requires:         python2-psutil >= 3.2.2

Requires:         python2-babel
Requires:         python-google-api-client >= 1.4.2

Requires:         python2-oslo-rootwrap >= 5.8.0
Requires:         python2-oslo-utils >= 3.33.0
Requires:         python2-oslo-serialization >= 2.18.0
Requires:         python2-oslo-db >= 4.27.0
Requires:         python2-oslo-context >= 2.19.2
Requires:         python2-oslo-concurrency >= 3.25.0
Requires:         python2-oslo-middleware >= 3.31.0
Requires:         python2-taskflow >= 2.16.0
Requires:         python2-oslo-messaging >= 5.29.0
Requires:         python2-oslo-policy >= 1.30.0
Requires:         python2-oslo-reports >= 1.18.0
Requires:         python2-oslo-service >= 1.24.0
Requires:         python2-oslo-versionedobjects >= 1.31.2

Requires:         iscsi-initiator-utils

Requires:         python2-osprofiler >= 1.4.0

Requires:         python-httplib2 >= 0.9.1
Requires:         python2-oauth2client >= 1.5.0

Requires:         python2-oslo-log >= 3.36.0
Requires:         python2-oslo-i18n >= 3.15.3
Requires:         python2-barbicanclient >= 4.0.0
Requires:         python2-requests >= 2.14.2
Requires:         python-retrying >= 1.2.3
Requires:         python2-pyparsing >= 2.1.0
Requires:         python2-pytz
Requires:         python-decorator
Requires:         python-enum34
Requires:         python-ipaddress

Requires:         python2-keystonemiddleware >= 4.17.0
Requires:         python2-keystoneauth1 >= 3.3.0

Requires:         python2-oslo-privsep >= 1.23.0

Requires:         python2-cryptography >= 1.7.2

Requires:         python2-defusedxml >= 0.5.0

%description -n   python-%{service}
%{common_desc}

This package contains the %{service} Python library.

%package -n python-%{service}-tests
Summary:        Cinder tests
Requires:       openstack-%{service} = %{epoch}:%{version}-%{release}

# Added test requirements
Requires:       python2-hacking
Requires:       python-anyjson
Requires:       python2-ddt
Requires:       python2-fixtures
Requires:       python2-mock
Requires:       python2-mox3
Requires:       python2-oslotest
Requires:       python2-subunit
Requires:       python2-testtools
Requires:       python2-testrepository
Requires:       python2-testresources
Requires:       python2-testscenarios
Requires:       python2-os-testr

%description -n python-%{service}-tests
%{common_desc}

This package contains the Cinder test files.

%if 0%{?with_doc}
%package doc
Summary:          Documentation for OpenStack Volume
Group:            Documentation

Requires:         %{name} = %{epoch}:%{version}-%{release}

BuildRequires:    graphviz

# Required to build module documents
BuildRequires:    python2-eventlet
BuildRequires:    python2-routes
BuildRequires:    python2-sqlalchemy
BuildRequires:    python-webob
# while not strictly required, quiets the build down when building docs.
BuildRequires:    python-migrate
BuildRequires:    python2-iso8601 >= 0.1.9

%description      doc
%{common_desc}

This package contains documentation files for %{service}.
%endif

%prep
%autosetup -n %{service}-%{upstream_version} -S git

find . \( -name .gitignore -o -name .placeholder \) -delete

find %{service} -name \*.py -exec sed -i '/\/usr\/bin\/env python/{d;q}' {} +

sed -i 's/%{version}.%{milestone}/%{version}/' PKG-INFO

# Remove the requirements file so that pbr hooks don't add it
# to distutils requires_dist config
%py_req_cleanup

%build
# Generate config file
PYTHONPATH=. oslo-config-generator --config-file=tools/config/%{service}-config-generator.conf

# Build
%{__python2} setup.py build

# Generate i18n files
# (amoralej) we can remove '-D cinder' once https://review.openstack.org/#/c/439501/ is merged
%{__python2} setup.py compile_catalog -d build/lib/%{service}/locale -D cinder

%install
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}

# docs generation requires everything to be installed first
export PYTHONPATH="$( pwd ):$PYTHONPATH"

%if 0%{?with_doc}
%{__python2} setup.py build_sphinx --builder html
# Fix hidden-file-or-dir warnings
rm -fr doc/build/html/.buildinfo
%endif

%{__python2} setup.py build_sphinx --builder man
mkdir -p %{buildroot}%{_mandir}/man1
install -p -D -m 644 doc/build/man/*.1 %{buildroot}%{_mandir}/man1/

# Setup directories
install -d -m 755 %{buildroot}%{_sharedstatedir}/%{service}
install -d -m 755 %{buildroot}%{_sharedstatedir}/%{service}/tmp
install -d -m 755 %{buildroot}%{_localstatedir}/log/%{service}

# Install config files
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}
install -p -D -m 640 %{SOURCE1} %{buildroot}%{_datadir}/%{service}/%{service}-dist.conf
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}/volumes
install -p -D -m 640 etc/%{service}/rootwrap.conf %{buildroot}%{_sysconfdir}/%{service}/rootwrap.conf
install -p -D -m 640 etc/%{service}/api-paste.ini %{buildroot}%{_sysconfdir}/%{service}/api-paste.ini
install -p -D -m 640 etc/%{service}/%{service}.conf.sample %{buildroot}%{_sysconfdir}/%{service}/%{service}.conf

# Install initscripts for services
install -p -D -m 644 %{SOURCE10} %{buildroot}%{_unitdir}/openstack-%{service}-api.service
install -p -D -m 644 %{SOURCE11} %{buildroot}%{_unitdir}/openstack-%{service}-scheduler.service
install -p -D -m 644 %{SOURCE12} %{buildroot}%{_unitdir}/openstack-%{service}-volume.service
install -p -D -m 644 %{SOURCE13} %{buildroot}%{_unitdir}/openstack-%{service}-backup.service

# Install sudoers
install -p -D -m 440 %{SOURCE20} %{buildroot}%{_sysconfdir}/sudoers.d/%{service}

# Install logrotate
install -p -D -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-%{service}

# Install pid directory
install -d -m 755 %{buildroot}%{_localstatedir}/run/%{service}

# Install rootwrap files in /usr/share/cinder/rootwrap
mkdir -p %{buildroot}%{_datarootdir}/%{service}/rootwrap/
install -p -D -m 644 etc/%{service}/rootwrap.d/* %{buildroot}%{_datarootdir}/%{service}/rootwrap/


# Symlinks to rootwrap config files
mkdir -p %{buildroot}%{_sysconfdir}/%{service}/rootwrap.d
for filter in %{_datarootdir}/os-brick/rootwrap/*.filters; do
ln -s $filter %{buildroot}%{_sysconfdir}/%{service}/rootwrap.d/
done

# Install i18n .mo files (.po and .pot are not required)
install -d -m 755 %{buildroot}%{_datadir}
rm -f %{buildroot}%{python2_sitelib}/%{service}/locale/*/LC_*/%{service}*po
rm -f %{buildroot}%{python2_sitelib}/%{service}/locale/*pot
mv %{buildroot}%{python2_sitelib}/%{service}/locale %{buildroot}%{_datadir}/locale

# Find language files
%find_lang %{service} --all-name

# Remove unneeded in production stuff
rm -f %{buildroot}/usr/share/doc/%{service}/README*

# Remove duplicate config files under /usr/etc/
rm -rf %{buildroot}%{_prefix}/etc

# FIXME(jpena): unit tests are taking too long in the current DLRN infra
# Until we have a better architecture, let's not run them when under DLRN
%if 0%{!?dlrn}
%check
OS_TEST_PATH=./%{service}/tests/unit ostestr --concurrency=2
%endif

%pre
getent group %{service} >/dev/null || groupadd -r %{service} --gid 165
if ! getent passwd %{service} >/dev/null; then
  useradd -u 165 -r -g %{service} -G %{service},nobody -d %{_sharedstatedir}/%{service} -s /sbin/nologin -c "OpenStack Cinder Daemons" %{service}
fi
exit 0

%post
%systemd_post openstack-%{service}-volume
%systemd_post openstack-%{service}-api
%systemd_post openstack-%{service}-scheduler
%systemd_post openstack-%{service}-backup

%preun
%systemd_preun openstack-%{service}-volume
%systemd_preun openstack-%{service}-api
%systemd_preun openstack-%{service}-scheduler
%systemd_preun openstack-%{service}-backup

%postun
%systemd_postun_with_restart openstack-%{service}-volume
%systemd_postun_with_restart openstack-%{service}-api
%systemd_postun_with_restart openstack-%{service}-scheduler
%systemd_postun_with_restart openstack-%{service}-backup

%files
%dir %{_sysconfdir}/%{service}
%config(noreplace) %attr(-, root, %{service}) %{_sysconfdir}/%{service}/%{service}.conf
%config(noreplace) %attr(-, root, %{service}) %{_sysconfdir}/%{service}/api-paste.ini
%config(noreplace) %attr(-, root, %{service}) %{_sysconfdir}/%{service}/rootwrap.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/openstack-%{service}
%config(noreplace) %{_sysconfdir}/sudoers.d/%{service}
%{_sysconfdir}/%{service}/rootwrap.d/
%attr(-, root, %{service}) %{_datadir}/%{service}/%{service}-dist.conf

%dir %attr(0750, %{service}, root) %{_localstatedir}/log/%{service}
%dir %attr(0755, %{service}, root) %{_localstatedir}/run/%{service}
%dir %attr(0755, %{service}, root) %{_sysconfdir}/%{service}/volumes

%{_bindir}/%{service}-*
%{_unitdir}/*.service
%{_datarootdir}/%{service}
%{_mandir}/man1/%{service}*.1.gz

%defattr(-, %{service}, %{service}, -)
%dir %{_sharedstatedir}/%{service}
%dir %{_sharedstatedir}/%{service}/tmp

%files -n python-%{service} -f %{service}.lang
%{?!_licensedir: %global license %%doc}
%license LICENSE
%{python2_sitelib}/%{service}
%{python2_sitelib}/%{service}-*.egg-info
%exclude %{python2_sitelib}/%{service}/test.py
%exclude %{python2_sitelib}/%{service}/tests

%files -n python-%{service}-tests
%license LICENSE
%{python2_sitelib}/%{service}/test.py
%{python2_sitelib}/%{service}/tests

%if 0%{?with_doc}
%files doc
%doc doc/build/html
%endif

%changelog
* Mon Jan 28 2019 Steve Linabery <slinaber@redhat.com> 1:12.0.4-8
- Add secret=true to fixed_key configuration parameter
- Retry on DBDeadLock affecting worker updates
- Consume quota when importing backup resource
- Handle rbd.OSError on broken RBD image
- Stop cleaning images to be deleted in remotefs driver
- Correct default policy file
- Remove cinder-tox-compliance job
- lvm: Avoid premature calls to terminate_connection for muiltiattach vols
- LVM: Disable multiattach for LIO iSCSI target
- Fix non iSCSI attach serialization
- SF ensure the correct volume is deleted

* Fri Jan 25 2019 Brian Rosmaita <brosmait@redhat.com> 1:12.0.4-7
- cinder-volume: Stop masking IOError different than ENOSPC (rhbz#1659264)

* Thu Jan 24 2019 Brian Rosmaita <brosmait@redhat.com> 1:12.0.4-6
- VMAX Driver - VMAX OS Upgrade Bug (rhbz#1664391)

* Fri Jan 11 2019 Lee Yarwood <lyarwood@redhat.com> 1:12.0.4-5
- lvm: Avoid premature calls to terminate_connection for muiltiattach vols (rhbz#1650429)

* Mon Jan 07 2019 Laura Sofia Enriquez <senrique@redhat.com> 1:12.0.4-4
- Ensure image utils don't block greenthreads (rhbz#1646940)

* Mon Nov 26 2018 Jon Schlueter <jschluet@redhat.com> 1:12.0.4-3
- Storwize: modify hyperswap host_site configuration
- Fix backup/restore error for ceph rbd backend
- VMAX Queens - 90 endpoint not compatible with unisphere 8.4
- Handling type's multiattach extra specs in API task flow

* Tue Oct 23 2018 Alan Bishop <abishop@redhat.com> 1:12.0.4-2
- nimble storage: support for force detach (rhbz#1640834)

* Tue Oct 16 2018 Jon Schlueter <jschluet@redhat.com> 1:12.0.4-1
- Update to 12.0.4 (rhbz#1639941)

* Mon Oct 15 2018 Elise Gafford <egafford@redhat.com> 1:12.0.3-7
- ScaleIO: Prevent usage of unsafe volumes (rhbz#1610148)

* Mon Oct 15 2018 Alan Bishop <abishop@redhat.com> 1:12.0.3-6
- NetApp SolidFire: Fix CG snapshot deletion (rhbz#1629049)
- NetApp SolidFire: Fix force_detach (rhbz#1638406)

* Tue Oct 09 2018 Brian Rosmaita <brosmait@redhat.com> 1:12.0.3-5
- Fix IPv6 for Cinder NetApp ONTAP drivers (rhbz#1635620)

* Tue Sep 04 2018 Elise Gafford <egafford@redhat.com> 1:12.0.3-4
- RBD: Enable cinder exclusive pool by default (rhbz#1624482)

* Fri Aug 31 2018 Elise Gafford <egafford@redhat.com> 1:12.0.3-3
- NetApp ONTAP: Fix driver force detach operations (rhbz#1622535)

* Wed Jul 18 2018 Jon Schlueter <jschluet@redhat.com> 1:12.0.3-2
- Fix RBD incremental backup
- NEC driver: Reuse iSCSI LUNs of detached volumes.
- NEC driver: Delete max volumes per pool limit.
- Fix quota error when deleting temporary volume (rhbz#1597735)
- GoodnessWeigher schedules non-type volumes
- HPE3PAR: Fix pointing to backend in group failover
- Storwize: self assign the SCSI lun id for volume attaching
- Storwize: filter active wwpns for NPIV
- [Unity] Return logged-out initiators
- ZFSSA handle non-existent snapshot
- Correct S-Series to DS-Series systems
- Update storage backends supported for Lenovo

* Mon Jun 18 2018 RDO <dev@lists.rdoproject.org> 1:12.0.3-1
- Update to 12.0.3

* Tue Jun  5 2018 Alan Bishop <abishop@redhat.com> 1:12.0.2-2
- Do not repeat log messages on stderr

* Mon Jun 04 2018 RDO <dev@lists.rdoproject.org> 1:12.0.2-1
- Update to 12.0.2

* Thu May 31 2018 Eric Harney <eharney@redhat.com> 1:12.0.1-0.20180418194614.c476898
- Fix handling of 'cinder_encryption_key_id' image metadata

* Thu Apr 26 2018 Eric Harney <eharney@redhat.com> 1:12.0.1-0.20180418194613.c476898
- Add Keystone v3 domain information to context

* Wed Apr 25 2018 Jon Schlueter <jschluet@redhat.com> 1:12.0.1-0.20180418194612.c476898
- Avoid second restart on offline upgrades (rhbz#1557331)

